package com.fxy.main.fragment;

import android.Manifest;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.widget.LinearLayoutManager;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;

import com.fxy.common.VersionUpgrades;
import com.elvishew.xlog.XLog;
import com.google.zxing.Result;
import com.fxy.baselibrary.base.BaseFragment;
import com.fxy.baselibrary.interfaces.OnRxScanerListener;
import com.fxy.baselibrary.language.other.CommSharedUtil;
import com.fxy.baselibrary.qrcode.ActivityScanerCode;
import com.fxy.baselibrary.tddialog.TDialog;
import com.fxy.baselibrary.tddialog.base.BindViewHolder;
import com.fxy.baselibrary.tddialog.base.TBaseAdapter;
import com.fxy.baselibrary.tddialog.list.TListDialog;
import com.fxy.R;
import com.fxy.constant.BaseConfig;
import com.fxy.fms.putIn.TallyStartMainActivity;
import com.fxy.helper.ScanHelper;


import java.util.ArrayList;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;


/**
 * 仓配业务主界面
 *
 * @author James.Jiang
 */
public class HomePagerFragment extends BaseFragment implements View.OnClickListener {

    /**
     * 搜索框
     */
    @BindView(R.id.search_view)
    LinearLayout searchView;
    /**
     * 二维码按钮
     */
    @BindView(R.id.ima_or_code)
    ImageView imaORCOde;

    //ll_put_in_menu_tc
    @BindView(R.id.ll_put_in_menu_tc)
    LinearLayout llPutInMenuTc;

    //
    //ll_put_out_menu
    @BindView(R.id.ll_put_out_menu_tc)
    LinearLayout llPutOutMenuTc;

    @BindView(R.id.ll_check_menu_tc)
    LinearLayout llCheckMenuTc;

    Unbinder bind;

    private TListDialog tListDialog;
    private ArrayList<String> datas = new ArrayList<>();
    public static final String TYPE = "type";

    @Nullable
    public static HomePagerFragment newInstance(@Nullable String steRes) {
        Bundle bundle = new Bundle();
        bundle.putString(TYPE, steRes);
        HomePagerFragment fragment = new HomePagerFragment();
        fragment.setArguments(bundle);
        return fragment;
    }

    @Override
    protected int getLayoutRes() {
        return R.layout.fragment_homepager;
    }

    @Override
    protected void initView(View rootView) {
        bind = ButterKnife.bind(this, rootView);
        ViewGroup parent = (ViewGroup) rootView.getParent();
        if (parent != null) {
            parent.removeView(rootView);
        }

        //从缓存读取客户端

        CommSharedUtil commSharedUtil = CommSharedUtil.getInstance(getActivity());
        String clientCode = commSharedUtil.getString(BaseConfig.CLIENT_CODE,"dhwms");


        try {
            //检查文件读写 权限
            if (ContextCompat.checkSelfPermission(getActivity(), Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED){
                ActivityCompat.requestPermissions(getActivity(), new String[]{ Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);
            }
        }catch (Exception e){
            XLog.e("获取读写权限出错："+e.getMessage());
        }


        //初始化扫码设置
        new ScanHelper(getActivity());

        //记录一下设备信息
        XLog.e("记录设备信息：\n厂商："+ Build.MANUFACTURER+"\n型号："+Build.MODEL+"\nandroid："+Build.VERSION.RELEASE+"");



        new Thread() {
            @Override
            public void run() {
                (new VersionUpgrades(getContext())).checkUpgrades();
            }
        }.start();

    }



    private void initAdapter() {

    }






    @Override
    protected void getBundleExtras(Bundle bundle) {

    }

    @Override
    protected void initLogic() {

    }


    /**
     * 绑定事件
     * @param v
     */
    @OnClick({R.id.search_view, R.id.ima_or_code,R.id.ivt_tally_tc,
            R.id.ivt_putaway_tc,R.id.ivt_check_list_tc,R.id.ivt_check_tc,R.id.ivt_cargo_storage_tc,R.id.ivt_cancel_storage_tc})
    public void onClick(View v) {
        Bundle bundle = new Bundle();
        switch (v.getId()) {
            case R.id.search_view:
                break;
            case R.id.ima_or_code:
                showListDialog();
                break;
            case R.id.ivt_tally_tc:
                bundle.putString("action","receive");
                intent2Page(getActivity(), TallyStartMainActivity.class, false,bundle);;
                break;
            case R.id.ivt_putaway_tc:
                bundle.putString("action","putaway");
                intent2Page(getActivity(), com.fxy.fms.putIn.PutAwayMainActivity.class, false,bundle);;
                break;
            case R.id.ivt_check_list_tc:
                bundle.putString("action","waitcheck");
                intent2Page(getActivity(), com.fxy.fms.check.WaitCheckMainActivity.class, false,bundle);;
                break;
            case R.id.ivt_check_tc:
                bundle.putString("action","waitcheck");
                intent2Page(getActivity(), com.fxy.fms.check.CheckStartMainActivity.class, false,bundle);;
                break;
            case R.id.ivt_cargo_storage_tc:
                bundle.putString("action","storage");
                intent2Page(getActivity(), com.fxy.fms.putOut.StorageStartMainActivity.class, false,bundle);;
                break;
            case R.id.ivt_cancel_storage_tc:
                bundle.putString("action","storage");
                intent2Page(getActivity(), com.fxy.fms.putOut.StorageCancelMainActivity.class, false,bundle);;
                break;
                //
            default:
                showToast("还没有配置点击事件");
                break;


        }
    }

    private void showListDialog() {
        if (tListDialog == null) {
            datas.add("扫一扫收货");
            datas.add("扫一扫上架");
            datas.add("扫一扫查库存");
            datas.add("扫描商家单证号");
            XLog.d(datas.toArray());
            tListDialog = (TListDialog) new TListDialog.Builder(getActivity().getSupportFragmentManager())
//                    .setScreenHeightAspect(getActivity(), 0.5f)
                    .setListLayoutRes(R.layout.dialog_recyclerview, LinearLayoutManager.VERTICAL)
                    .setDimAmount(0.6f)     //设置弹窗背景透明度(0-1f)
                    .setCancelOutside(true)//弹窗在界面外是否可以点击取消
//                    .setHeight(600)
                    .setScreenWidthAspect(getActivity(), 0.8f)
                    .setGravity(Gravity.CENTER)
                    .setAdapter(new TBaseAdapter<String>(R.layout.item_dialog_list_one, datas) {

                        @Override
                        protected void onBind(BindViewHolder holder, int position, String s) {
                            holder.setText(R.id.tv_dialog_list, s);
                        }
                    })
                    .setOnAdapterItemClickListener(new TBaseAdapter.OnAdapterItemClickListener<String>() {
                        @Override
                        public void onItemClick(BindViewHolder holder, int position, String s, TDialog tDialog) {
                            ActivityScanerCode.setScanerListener(mScanerListener);
                            ActivityScanerCode.intent2Activity(getActivity(), s);
                            tDialog.dismiss();
                        }
                    })
                    .create()
                    .show();
        } else {
            if (!tListDialog.isVisible()) {
                tListDialog.show();
            }
        }
    }

    private OnRxScanerListener mScanerListener = new OnRxScanerListener() {
        @Override
        public void onSuccess(String type, Result result) {
            if ("扫一扫收货".equals(type)) {
                showToast("扫一扫收货" + result.getText());
            } else if ("扫一扫上架".equals(type)) {
                showToast("扫一扫上架" + result.getText());
            } else if ("扫一扫查库存".equals(type)) {
                showToast("扫一扫查库存" + result.getText());
            } else if ("扫描商家单证号".equals(type)) {
                showToast("扫描商家单证号" + result.getText());
            }
        }

        @Override
        public void onFail(String type, String message) {

        }
    };

    @Override
    public void onDestroy() {
        super.onDestroy();
        bind.unbind();
    }


}
